/*

fits.cpp version 1.0

Copyright Yann OLLIVIER 1996-2000

This software may be freely distributed as is, including this whole notice.

It may be modified, but any modification should include this whole 
notice as is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice.
If you want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#include "fits.h"

char *FileToStr(FILE*f)
{
  fseek(f,0,0);
  long n=0;char s=1;
  while(s&&!feof(f)){
    fread(&s,sizeof(char),1,f);n++;
  };
  char *str=new char [n];
  fseek(f,0,0);
  fread(str,sizeof(char),n-1,f);str[n-1]=0;
  return str;
}

char * SupprSpaces(char*s)
{
  int i,n;char*s1;
  for(s1=s;*s1==' ';s1++);
  for(n=0;s1[n];n++);
  for(i=n-1;i>=0&&s1[i]==' ';i--);
  char *t=new char[i+2];for(n=0;n<i+1;n++)t[n]=s1[n];
  t[i+1]=0;
  return t;
}

void NewModLin(TMod*&PModR)
{
  TModLin*PMod=new TModLin();PModR=PMod;
  char Texte[70]="";
  printf("Y = a X + b. \nKnown parameters:\n"
	 "(Enter a list such as a=xxx, b=xxx)\n");
  fgets(Texte,70,stdin);
  PMod->ai=0;PMod->bi=0;
  char *s=strtok(Texte,"="),*s2;
  for(int j=0;j<2;j++)if(s!=NULL){
    s2=strtok(NULL,",");
    if(!strcmp(SupprSpaces(s),"a"))
      {PMod->ai=1;PMod->a=atof(s2);}else
	if(!strcmp(SupprSpaces(s),"b"))
	  {PMod->bi=1;PMod->b=atof(s2);};
    s=strtok(NULL,"=");
  };
}

void NewModPoly(TMod*&PModR)
{
  TModPoly* PMod=new TModPoly();PModR=PMod;
  char Texte[10]="";
  printf("Degree:");fgets(Texte,10,stdin);
  int n=atoi(Texte);if(n<0)n=0;
  PMod->deg=n;
  PMod->a.Destroy();
  PMod->ai.Destroy();
  int d;
  for(d=0;d<=n;d++){
    PMod->a.CopyObject(0,0);
    PMod->ai.CopyObject(0,0);
  };
  char*Texte2=new char[40*(n+1)];strcpy(Texte2,"");
  printf("Y = an X^n + ... + a1 X + a0. \nKnown parameters:\n"
	 "(Enter a list such as a1=xxx, a3=xxx...)\n");
  fgets(Texte2,40*(n+1),stdin);
  char *s=strtok(Texte2,"="),*s2,s3[10];
  for(int j=0;j<=n;j++)if(s!=NULL){
    s2=strtok(NULL,",");
    for(d=0;d<=n;d++){
      sprintf(s3,"a%i",d);
      if(!strcmp(SupprSpaces(s),s3)){
	PMod->ai[d]=1;
	PMod->a[d]=atof(s2);};
    };
    s=strtok(NULL,"=");
  };
}

void NewModExp1(TMod*&PModR)
{
  TModExp1*PMod=new TModExp1();PModR=PMod;
  char Texte[100]="";
  printf("Y = a exp(b X) + c. \nKnown parameters:\n"
	 "(Enter a list such as a=xxx, c=xxx...)\n");
  fgets(Texte,100,stdin);
  PMod->ai=0;PMod->bi=0;
  PMod->ci=0;
  char *s=strtok(Texte,"="),*s2;
  for(int j=0;j<3;j++)if(s!=NULL){
    s2=strtok(NULL,",");
    if(!strcmp(SupprSpaces(s),"a"))
      {PMod->ai=1;PMod->a=atof(s2);
      }else	if(!strcmp(SupprSpaces(s),"b"))
	{PMod->bi=1;PMod->b=atof(s2);
	}else	if(!strcmp(SupprSpaces(s),"c"))
	  {PMod->ci=1;PMod->c=atof(s2);};
    s=strtok(NULL,"=");
  };
}

void NewModExp3(TMod*&PModR)
{
  TModExp3* PMod=new TModExp3();PModR=PMod;
  char Texte[10]="";
  printf("Degree of the polynomial:");fgets(Texte,10,stdin);
  int n=atoi(Texte);if(n<0)n=0;
  PMod->deg=n;
  PMod->a.Destroy();
  PMod->ai.Destroy();
  PMod->bi=0;
  int d;
  for(d=0;d<=n;d++){
    PMod->a.CopyObject(0,0);
    PMod->ai.CopyObject(0,0);
  };
  char*Texte2=new char[40*(n+2)];strcpy(Texte2,"");
  printf("Y = (an X^n + ... + a1 X + a0) exp(b X). \nKnown parameters:\n"
	 "(Enter a list such as a1=xxx, a3=xxx...)\n");
  fgets(Texte2,40*(n+2),stdin);
  char *s=strtok(Texte2,"="),*s2,s3[10];
  for(int j=0;j<=n+1;j++)if(s!=NULL){
    s2=strtok(NULL,",");
    for(d=0;d<=n;d++){
      sprintf(s3,"a%i",d);
      if(!strcmp(SupprSpaces(s),s3)){
	PMod->ai[d]=1;
	PMod->a[d]=atof(s2);};
    };
    if(!strcmp(SupprSpaces(s),"b")){
      PMod->bi=1;
      PMod->b=atof(s2);};
    s=strtok(NULL,"=");
  };
}

void NewModLog1(TMod*&PModR)
{
  TModLog1* PMod=new TModLog1();PModR=PMod;
  char Texte[100]="";
  printf("Y = a log(b X + c). \nKnown parameters:\n"
	 "(Enter a list such as a=xxx, b=xxx)\n");
  fgets(Texte,100,stdin);
  PMod->ai=0;PMod->bi=0;
  PMod->ci=0;
  char *s=strtok(Texte,"="),*s2;
  for(int j=0;j<3;j++)if(s!=NULL){
    s2=strtok(NULL,",");
    if(!strcmp(SupprSpaces(s),"a")){
      PMod->ai=1;PMod->a=atof(s2);
    }else if(!strcmp(SupprSpaces(s),"b"))
      {PMod->bi=1;PMod->b=atof(s2);
      }else if(!strcmp(SupprSpaces(s),"c"))
	{PMod->ci=1;PMod->c=atof(s2);};
    s=strtok(NULL,"=");
  }
}

void NewModPuis(TMod*&PModR)
{
  TModPuis*PMod=new TModPuis();PModR=PMod;
  char Texte[140]="";
  printf("Y = a (X + b)^c +d. \nKnown parameters:\n"
	 "(Enter a list such as a=xxx, b=xxx)\n");
  fgets(Texte,140,stdin);
  PMod->ai=0;PMod->bi=0;
  PMod->ci=0;PMod->di=0;
  char *s=strtok(Texte,"="),*s2;
  for(int j=0;j<4;j++)if(s!=NULL){
    s2=strtok(NULL,",");
    if(!strcmp(SupprSpaces(s),"a")){
      PMod->ai=1;PMod->a=atof(s2);
    }else if(!strcmp(SupprSpaces(s),"b")){
      PMod->bi=1;PMod->b=atof(s2);
    }else if(!strcmp(SupprSpaces(s),"c")){
      PMod->ci=1;PMod->c=atof(s2);
    }else if(!strcmp(SupprSpaces(s),"d")){
      PMod->di=1;PMod->d=atof(s2);
    }
    s=strtok(NULL,"=");
  }
}

void NewModSin(TMod*&PModR)
{
  TModSin*PMod=new TModSin();PModR=PMod;
  char Texte[140]="";
  printf("Y = a sin(b X + c) + d. \nKnown parameters:\n"
	 "(Enter a list such as a=xxx, b=xxx)\n");
  fgets(Texte,140,stdin);
  PMod->ai=0;PMod->bi=0;
  PMod->ci=0;PMod->di=0;
  char *s=strtok(Texte,"="),*s2;
  for(int j=0;j<4;j++)if(s!=NULL){
    s2=strtok(NULL,",");
    if(!strcmp(SupprSpaces(s),"a")){
      PMod->ai=1;PMod->a=atof(s2);
    }else if(!strcmp(SupprSpaces(s),"b")){
      PMod->bi=1;PMod->b=atof(s2);
    }else if(!strcmp(SupprSpaces(s),"c")){
      PMod->ci=1;PMod->c=atof(s2);
    }else if(!strcmp(SupprSpaces(s),"d")){
      PMod->di=1;PMod->d=atof(s2);};
    s=strtok(NULL,"=");
  }
}

int main(int nargs,char**vargs)
{
  if(nargs!=2){
    printf("No input file!\n"
	   "Usage: fits <file> where file is a file containing a list of pairs of numbers in text format.\n");
    return 0;
  }
  FILE*f=fopen(vargs[1],"rb");
  char *s=FileToStr(f);
  fclose(f);
  long n,i;char *s2=s;char **t=new (char*)(NULL);
  for(n=0;;n++,s2=*t){
    strtod(s2,t);if(*t==s2)break;
  }
  if(!n){printf("No data in file!\n");return 0;}
  if(n%2){n--;printf("Odd number of entries. Last one will be ignored.\n");}
	printf("Data:\n");
  n/=2;
  TMatrix X(n,1),Y(n,1);
  s2=s;t=new (char*)(NULL);
  for(i=0;i<n;i++){
    X(i)=strtod(s2,t);s2=*t;
    Y(i)=strtod(s2,t);s2=*t;
    printf("%Lg\t%Lg\n",X(i),Y(i));
  }

  printf("Choose a model:\n"
	 " (1) Y = a X + b\n"
	 " (2) Y = an X^n + ... + a1 X + a0\n"
	 " (3) Y = a exp(b X) + c\n"
	 " (4) Y = (an X^n + ... + a1 X + a0) exp(b X)\n"
	 " (5) Y = a log(b X + c)\n"
	 " (6) Y = a (X + b)^c +d\n"
	 " (7) Y = a sin(b X + c) + d\n"
	 );
  printf("Model number: ");char v[3]="";fgets(v,3,stdin);

  int type=atoi(v);TMod*PMod;
  if(type==1)NewModLin(PMod);
  else if(type==2)NewModPoly(PMod);
  else if(type==3)NewModExp1(PMod);
  else if(type==4)NewModExp3(PMod);
  else if(type==5)NewModLog1(PMod);
  else if(type==6)NewModPuis(PMod);
  else if(type==7)NewModSin(PMod);
  else{printf("Bad number.\n");return 0;}

  PMod->Etablit(&X,&Y);
  printf("\nResult:\n%s\n",PMod->expr);
  printf("Correlation: %g%%\n",PMod->stat.corr*100);  

  char u[strlen(vargs[1])+5];
  sprintf(u,"%s.est",vargs[1]);
  f=fopen(u,"wb");
  TVal val;
  for(i=0;i<n;i++){
    val=PMod->f(X(i));
    if(val.IsDefined)
      fprintf(f,"%Lg\t%Lg\t%g\n",X(i),Y(i),PMod->f(X(i)).v);
    else fprintf(f,"%Lg\t%Lg\tNAN\n",X(i),Y(i));
  }
  fclose(f);
  printf("Estimated output written in %s\n",u);

  return 0;
}

