/*

fits.h version 1.0

Copyright Yann OLLIVIER 1996

This software may be freely distributed as is, including this whole notice.

It may be modified, but any modification should include this whole 
notice as is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice.
If you want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>

#include "../lists.h"
#include "../matrices.h"

typedef TMatrix* PTMatrix;

typedef struct{double moy1,moy2,s1,s2,cov,corr,eqm;}TStat;

typedef struct{char IsDefined;double v;}TVal;

class TMod{
public:
  char*expr;
  TStat stat;
  TMod(){expr=new char[0];};
  ~TMod(){delete[] expr;};
  virtual void Etablit(PTMatrix,PTMatrix)=0;
  virtual TVal f(double)=0;
  char imp;
};
class TModLin:public TMod
{public:
  double a,b;char ai,bi;
  void Etablit(PTMatrix,PTMatrix);
  TVal f(double);
};
class TModPoly:public TMod
{public:
  int deg;TList<double> a;TList<char> ai;
  void Etablit(PTMatrix,PTMatrix);
  TVal f(double);~TModPoly(){a.Destroy();ai.Destroy();};
};
class TModExp1:public TMod
{public:
  double a,b,c;char ai,bi,ci;
  void Etablit(PTMatrix,PTMatrix);
  TVal f(double);
};
class TModExp3:public TMod
{public:
  double b;TList<double>a;int deg;
  TList<char>ai;char bi;
  void Etablit(PTMatrix,PTMatrix);
  TVal f(double);~TModExp3(){a.Destroy();ai.Destroy();};
};
class TModLog1:public TMod
{public:
  double a,b,c;char ai,bi,ci;
  void Etablit(PTMatrix,PTMatrix);
  TVal f(double);
};
class TModPuis:public TMod
{public:
  double a,c,b,d;char ai,bi,ci,di;
  void Etablit(PTMatrix,PTMatrix);
  TVal f(double);
};
class TModSin:public TMod
{public:
  double a,b,c,d;char ai,bi,ci,di;
  void Etablit(PTMatrix,PTMatrix);
  TVal f(double);
};

