#ifndef __MATRICES_H
#define __MATRICES_H

#ifndef __STDIO_H
#include<stdio.h>
#endif

#ifndef __MATH_H
#include<math.h>
#endif

#include<complex>

//Class definitions for matrixes
//A TMatrix is indexed from (0,0) to (nl-1,nc-1) and not from (1,1) to (nl,nc)

class TMatrix{
	long double * Pa(int i,int j){return(PMatrix+i*nc+j);};  //Old implementation
	inline long double a(int i,int j)const{return(*(PMatrix+i*nc+j));};  //Old implementation
	void Seta(int i,int j,long double v){*Pa(i,j)=v;};  //Old implementation
public:
	long double * PMatrix;
	int nl,nc;
	TMatrix(const TMatrix &);
	TMatrix(int,int,long double *);
	TMatrix(int,int=1,long double = 0.0);
	//TMatrix(){TMatrix(0,0,(long double)0);};
	~TMatrix(){delete[] PMatrix;};
	long double & operator()(int i,int j){return (*(PMatrix+i*nc+j));};
	const long double & operator()(int i,int j)const {return (*(PMatrix+i*nc+j));};
	long double & operator()(int i){return(*(PMatrix+i*nc));};
	const long double & operator()(int i)const {return(*(PMatrix+i*nc));};
	int Resize(int,int,long double);
	int DelRow(int,int);int DelCol(int,int);
	int InsRow(int,int);int InsCol(int,int);
	TMatrix& operator=(const TMatrix&);
	friend int operator==(const TMatrix&,const TMatrix&);
	friend int operator!=(const TMatrix&,const TMatrix&);
	TMatrix operator+()const;TMatrix operator-()const;
	friend TMatrix operator+(const TMatrix&,const TMatrix&);
	friend TMatrix operator+(const long double&,const TMatrix&);
	friend TMatrix operator+(const TMatrix&,const long double&);
	friend TMatrix operator-(const TMatrix&,const TMatrix&);
	friend TMatrix operator*(const long double&,const TMatrix&);
	friend TMatrix operator*(const TMatrix&,const TMatrix&);
	TMatrix& operator+=(const TMatrix&);
	TMatrix& operator+=(const long double&);
	TMatrix& operator-=(const TMatrix&);
	TMatrix& operator*=(const long double&);
	TMatrix& operator*=(const TMatrix&); 
	TMatrix operator!()const;  //Transpose-conjugate of TMatrix
	TMatrix operator~()const;	//Inverse of TMatrix
	friend long double det(const TMatrix&);
	friend int rank(const TMatrix&);
	friend TMatrix MatrixId(int);
	friend TMatrix exp(const TMatrix&);
	friend long double max(const TMatrix&);
	friend long double min(const TMatrix&);
	friend long double trace(const TMatrix&);
};

const TMatrix MatrixNull(0,0,0.0);

bool LUdec(TMatrix& A);
bool PLUdec(TMatrix& A,int*& Pvect);
TMatrix Solve(const TMatrix& A,const TMatrix& bvect);
void GramSchmidtify(TMatrix& A);
bool LUPdec(TMatrix& A,int*& Pvect);
TMatrix kerbase(const TMatrix& A);

#endif
